local AddonName, ec = ...
local HandyNotes = LibStub("AceAddon-3.0"):GetAddon("HandyNotes")
local EphemeralCrystals = LibStub("AceAddon-3.0"):NewAddon(AddonName, "AceEvent-3.0")
ec.EphemeralCrystals = EphemeralCrystals
local Icon = "Interface\\Addons\\HandyNotes_EphemeralCrystals\\Icon"
local crystals = {
    ["Azsuna"] = {
        [54503350] = { name="Ephemeral Crystal", zone="7334", note="In north of Nar'thalas academy" },
        [37403220] = { name="Ephemeral Crystal", zone="7334" },
        [50002090] = { name="Ephemeral Crystal", zone="7334", note="Azurewing repose, in a cave, next to a wall" },
        [61003000] = { name="Ephemeral Crystal", zone="7334", note="In a cave , where a npc Kira Iresoul stays" },
        [47106170] = { name="Ephemeral Crystal", zone="7334", note="Left from Oceanus cove, on a hill" },
        [53402790] = { name="Ephemeral Crystal", zone="7334" },
        [59703860] = { name="Ephemeral Crystal", zone="7334" },
        [67003370] = { name="Ephemeral Crystal", zone="7334" },
        [60005300] = { name="Ephemeral Crystal", zone="7334" },
        [29903600] = { name="Ephemeral Crystal", zone="7334" },
        [44105980] = { name="Ephemeral Crystal", zone="7334" },
        [60105320] = { name="Ephemeral Crystal", zone="7334" },
        [45501720] = { name="Ephemeral Crystal", zone="7334" },
        [51006100] = { name="Ephemeral Crystal", zone="7334" },
        [44105980] = { name="Ephemeral Crystal", zone="7334" },
        [60004900] = { name="Ephemeral Crystal", zone="7334" },
        [57502660] = { name="Ephemeral Crystal", zone="7334" },
        [47203300] = { name="Ephemeral Crystal", zone="7334", note="Azurewing repose, south" },
        [37403220] = { name="Ephemeral Crystal", zone="7334" },
        [36003600] = { name="Ephemeral Crystal", zone="7334" },
        [34803530] = { name="Ephemeral Crystal", zone="7334", note="Nor'danil wellspring, south" },
        [29903600] = { name="Ephemeral Crystal", zone="7334" },
        [42200850] = { name="Ephemeral Crystal", zone="7334", note="Northern coast, Lost Orchard" },
        [43001800] = { name="Ephemeral Crystal", zone="7334" },
        [45501720] = { name="Ephemeral Crystal", zone="7334" },
        [50002090] = { name="Ephemeral Crystal", zone="7334" },
        [61003000] = { name="Ephemeral Crystal", zone="7334" },
        [52292524] = { name="Ephemeral Crystal", zone="7334" },
        [53083603] = { name="Ephemeral Crystal", zone="7334" },
        [59084488] = { name="Ephemeral Crystal", zone="7334" },
        [34851714] = { name="Ephemeral Crystal", zone="7334" },
        [56004000] = { name="Ephemeral Crystal", zone="7334" },
        [67004600] = { name="Ephemeral Crystal", zone="7334" },
        [67005200] = { name="Ephemeral Crystal", zone="7334" },
        [48704850] = { name="Ephemeral Crystal", zone="7334" },
        [50400780] = { name="Ephemeral Crystal", zone="7334" },
        [65494247] = { name="Ephemeral Crystal", zone="7334" },
        [59373833] = { name="Ephemeral Crystal", zone="7334" },
        [46954893] = { name="Ephemeral Crystal", zone="7334" },
        [42400880] = { name="Ephemeral Crystal", zone="7334" },
        [45700920] = { name="Ephemeral Crystal", zone="7334" },
        [64803790] = { name="Ephemeral Crystal", zone="7334" },
        [61103890] = { name="Ephemeral Crystal", zone="7334" },
        [52007100] = { name="Ephemeral Crystal", zone="7334" },
        [62005400] = { name="Ephemeral Crystal", zone="7334" },
        [68002300] = { name="Ephemeral Crystal", zone="7334" },
        [35002200] = { name="Ephemeral Crystal", zone="7334" },
        [58704500] = { name="Ephemeral Crystal", zone="7334" },
        [57904260] = { name="Ephemeral Crystal", zone="7334" },
        [62535236] = { name="Ephemeral Crystal", zone="7334" },
        [52411344] = { name="Ephemeral Crystal", zone="7334" },
        [40553629] = { name="Ephemeral Crystal", zone="7334" },
        [50485699] = { name="Ephemeral Crystal", zone="7334", note="in a cave" },
        [62734070] = { name="Ephemeral Crystal", zone="7334", note="near the eye of aszhara dungeon entrance" },
        [58814502] = { name="Ephemeral Crystal", zone="7334", note="inside a cave very near the last crystal" },
    },
}

------------------------------------------------------------------------

local EphemeralCrystalsHandler = {}

function EphemeralCrystalsHandler:OnEnter(mapFile, coord)
	local tooltip = self:GetParent() == WorldMapButton and WorldMapTooltip or GameTooltip
	if self:GetCenter() > UIParent:GetCenter() then
		tooltip:SetOwner(self, "ANCHOR_LEFT")
	else
		tooltip:SetOwner(self, "ANCHOR_RIGHT")
	end
	mapFile = gsub(mapFile, "_terrain%d+$", "")
	local crystal = crystals[mapFile] and crystals[mapFile][coord]
	if crystal then
		tooltip:AddLine(crystal.name)
		if crystal.note then
			tooltip:AddLine(crystal.note, 1, 1, 1)
		end
		tooltip:Show()
	end
end

function EphemeralCrystalsHandler:OnLeave(mapFile, coord)
	local tooltip = self:GetParent() == WorldMapButton and WorldMapTooltip or GameTooltip
	tooltip:Hide()
end

------------------------------------------------------------------------

if TomTom then
	local function setWaypoint(mapFile, coord)
		local crystal = crystals[mapFile] and crystals[mapFile][coord]
		if not crystal then return end

		local waypoint = crystal.waypoint
		if waypoint and TomTom:IsValidWaypoint(waypoint) then
			return
		end

		local x, y = HandyNotes:getXY(coord)
		crystal.waypoint = TomTom:AddMFWaypoint(crystal.zone, nil, x, y, {
			title = crystal.name,
			cleardistance = 0,
			minimap = true,
			world = true
		})
	end

	local CURRENT_MAP, CURRENT_COORD

	local function setThisWaypoint()
		setWaypoint(CURRENT_MAP, CURRENT_COORD)
	end

	local function setAllZoneWaypoints()
		local coords = crystals[CURRENT_MAP]
		for coord, crystal in pairs(coords) do
			if crystal.name then
				setWaypoint(CURRENT_MAP, coord)
			end
		end
		TomTom:SetClosestWaypoint()
	end

	local function setAllWaypoints()
		for mapFile, coords in pairs(crystals) do
			for coord, crystal in pairs(coords) do
				if crystal.name then
					setWaypoint(mapFile, coord)
				end
			end
		end
		TomTom:SetClosestWaypoint()
	end

	function EphemeralCrystalsHandler:OnClick(button, down, mapFile, coord)
		if down or button ~= "RightButton" then
			return
		end
		mapFile = gsub(mapFile, "_terrain%d+$", "")
		if IsControlKeyDown() then
			CURRENT_MAP, CURRENT_COORD = mapFile, coord
		else
			setWaypoint(mapFile, coord)
		end
	end
end

------------------------------------------------------------------------

do
	local function iterator(crystals, prev)
		if not crystals then return end
		local coord, crystal = next(crystals, prev)
		while crystal do
			if crystal.name then
				-- coord, mapFile2, iconpath, scale, alpha, level2
				return coord, nil, Icon, ec.db.icon_scale, ec.db.icon_alpha
			end
			coord, crystal = next(crystals, coord)
		end
	end

	function EphemeralCrystalsHandler:GetNodes(mapFile, minimap, dungeonLevel)
		mapFile = gsub(mapFile, "_terrain%d+$", "")
		return iterator, crystals[mapFile]
	end
end

------------------------------------------------------------------------
-- Addon initialization, enabling and disabling

function EphemeralCrystals:OnInitialize()
    -- Set up our database
    self.db = LibStub("AceDB-3.0"):New(AddonName.."DB", ec.defaults)
    ec.db = self.db.profile
    ec.hidden = self.db.char.hidden
    HandyNotes:RegisterPluginDB(AddonName:gsub("HandyNotes_", ""), EphemeralCrystalsHandler, ec.options)
end

function EphemeralCrystals:Refresh()
    self:SendMessage("HandyNotes_NotifyUpdate", AddonName:gsub("HandyNotes_", ""))
end

local Addon = CreateFrame("Frame")
Addon:SetScript("OnEvent", function(self, event, ...) return self[event](self, ...) end)